/**
 * Hlavni program predvadejici tridu Trideni.
 *
 * FILE: Main.java
 * @author Martin Sloup (A04372), 13. krouzek, FAV - Informatika
 * @version 1.0, 12/04/04
 */
// naimportujeme potrebne balicky
import java.io.*;

public class Main {
	public static void main(String[] args) {
		// v cele ukazce budeme pouzivat pole, tak ho tady definujeme
		int[] pole;
		// promena pro ulozeni klavesy z volby
		int klavesa = 0;
				
		// vytvoreni objektu pro zapis do souboru
		FileLog log = null;
		// vytvoreni objektu pro trideni
		Trideni sort = new Trideni();

		// zobrazime hlavicku programu
		Tools.hlavickaProgramu();

		// kez by existoval prikaz na vymaz obrzovky. Tak to tedy bude neprehledne

		//zeptame se, zda se bude logovat do souboru
		do {
			System.out.println("* Chcete ukladat nejdulezitejsi informace do souboru?");
			System.out.println("*   1. Ano.");
			System.out.println("*   2. Ne.");
			System.out.println();
			System.out.print("* Vase volba?: ");
			klavesa = VstupData.ctiInt();
			System.out.println();
			System.out.println();
		// uvazujeme jen klavesy 1 a 2, jinak opakujeme zadani otazky
		} while ((klavesa > 2) || (klavesa < 1));

		// pokud byla zadana klavesa 1, zacneme logovat
		if (klavesa==1) log = new FileLog("log.txt");

		// zeptame se, jake pole mame vytvorit
		do {
			System.out.println("* Jake pole chcete vytvorit?");
			System.out.println("*   1. Pole s nahodnymi hodnotamy.");
			System.out.println("*   2. Pole s rucne zadanymi hodnotamy.");
			System.out.println("*   3. Ukoncit program.");
			System.out.println();
			System.out.print("* Vase volba?: ");
			klavesa = VstupData.ctiInt();
			System.out.println();
			System.out.println();
		// uvazujeme jen klavesy 1 - 3, jinak opakujeme zadani otazky
		} while ((klavesa > 3) || (klavesa < 1));
		
		// pokud byla zadana klavesa 3, tak nebudeme pokracovat
		if (klavesa!=3) {
			if (klavesa==1) {
				/*
				 * pokud byla zmacknuta klavesa 1, tak vytvorime pometovy 
				 * prostor pro pole a naplnime ho nahodnymi cisly + zapiseme
				 * nejaky text do souboru
				 */
				if (log!=null) log.println("V programu bylo pracovano s polem naplnenym nahodnymi cisly.");
				System.out.print("* Velikost pole?: ");
				pole = Tools.RandomArray(VstupData.ctiInt());
				if (log!=null) log.println("Velikost pole byla: "+pole.length);
			} else {
				/*
				 * pokud byla zadana tedy klavesa 2, tak budeme zadvat hodnoty
				 * rucne, vytvorime pole a for cyklem se budeme ptat na potrebne
				 * hodnoty + zapiseme nejaky text do souboru
				 */
				if (log!=null) log.println("V programu bylo pracovano s polem naplnenym rucne zadanymi hodnotamy.");
				System.out.print("* Velikost pole?: ");
				pole = new int[VstupData.ctiInt()];
				if (log!=null) log.println("Velikost pole byla: "+pole.length);
				for(int i=0;i<pole.length;i++) {
					System.out.print("* "+i+". prvek?: ");
					pole[i] = VstupData.ctiInt();
				}
				
			}
			System.out.println();
			System.out.println();
			
			if (log!=null) {
				log.println();
				log.println();
			}
			
			// zapis textu do souboru
			if (log!=null) log.println("Vypisuji pole, ktere bylo pred tridenim:");
			
			// zeptame se, zda chceme vypsat zadane pole
			do {
				System.out.print("* Chcete vypsat pole? (1=ANO, 0=NE):");
				klavesa = VstupData.ctiInt();
				System.out.println();
				System.out.println();
			// uvazujeme jen klavesy 0 a 1, jinak opakujeme zadani otazky
			} while ((klavesa > 1) || (klavesa < 0));
			if (klavesa==1) {
				//pokud je zmacknuta klavesa 1, vypiseme pole
				System.out.println("---{ Vypis pole }---------------------------------------");
				for(int i=0;i<pole.length;i++) { 
					System.out.println(pole[i]+" ");
					if (log!=null) log.println(pole[i]+" ");
				}
				System.out.println("--------------------------------------------------------");
				System.out.println();
				System.out.println();
			} else {
				// pokud je zapnut zapis do souboru, tak tam zapiseme pole
				if (log!=null) for(int i=0;i<pole.length;i++) log.print(pole[i]+" ");
			}
			
			if (log!=null) {
				log.println();
				log.println();
			}
			
			// zeptame se jakou tridici metodou se ma seradit pole
			do {
				System.out.println("* Jakou metodou chcete setridit pole?");
				System.out.println("*   1. Setridit InsertSortem vzestupne [A-Z].");
				System.out.println("*   2. Setridit InsertSortem sestupne [Z-A].");
				System.out.println("*   3. Setridit SelectSortem vzestupne [A-Z].");
				System.out.println("*   4. Setridit SelectSortem sestupne [Z-A].");
				System.out.println("*   5. Setridit BubbleSortem vzestupne [A-Z].");
				System.out.println("*   6. Setridit BubbleSortem sestupne [Z-A].");
				System.out.println();
				System.out.print("* Vase volba?: ");
				klavesa = VstupData.ctiInt();
				System.out.println();
				System.out.println();
			// uvazujeme jen klavesy 1 - 6, jinak opakujeme zadani otazky
			} while ((klavesa > 6) || (klavesa < 1));
			// vypiseme na obrazovku text o tom, ze tridime, aby se uzivatel nestrachoval 
			System.out.print("* Tridim... ");
			
			// zapiseme text do souboru
			if (log!=null) log.print("Vyse vypsane pole bylo setrideno metodou");
			//vybereme switchem, jakou metodou budeme tridit
			switch(klavesa) {
				case 1:
					if (log!=null) log.println(" InsertSort (vzestupne).");
					sort.InsertSortASC(pole);
					break;
				case 2:
					if (log!=null) log.println(" InsertSort (sestupne).");
					sort.InsertSortDESC(pole);
					break;
				case 3:
					if (log!=null) log.println(" SelectSort (vzestupne).");
					sort.SelectSortASC(pole);
					break;
				case 4:
					if (log!=null) log.println(" SelectSort (sestupne).");
					sort.SelectSortDESC(pole);
					break;
				case 5:
					if (log!=null) log.println(" BubbleSort (vzestupne).");
					sort.BubbleSortASC(pole);
					break;
				case 6:
					if (log!=null) log.println(" BubbleSort (sestupne).");
					sort.BubbleSortDESC(pole);
					break;
			}
			// taaaak a ted vypiseme na obrazovku text, ze je trideni do konceno
			System.out.println("HOTOVO!");
			System.out.println();
			System.out.println();
			// zapiseme text do souboru
			if (log!=null) log.println("Vypisuji setridene pole:");
			
			// zeptame se uzivatele, zda chce vypsat pole
			do {
				System.out.print("* Chcete vypsat pole? (1=ANO, 0=NE):");
				klavesa = VstupData.ctiInt();
				System.out.println();
				System.out.println();
			// uvazujeme jen klavesy 0 a 1, jinak opakujeme zadani otazky
			} while ((klavesa > 1) || (klavesa < 0));			
			if (klavesa==1) {
				// pokud byla zmacknuta klavesa 1, vypiseme pole a to i do souboru
				System.out.println("---{ Vypis pole }---------------------------------------");
				for(int i=0;i<pole.length;i++) {
					System.out.println(pole[i]);
					if (log!=null) log.println(pole[i]+" ");
				}
				System.out.println("--------------------------------------------------------");
				System.out.println();
				System.out.println();
			} else {
				/*
				 * pokud to nebyla klavesa 1, tak to stejne zapiseme do souboru,
				 * pokud tedy je zapnute logovani
				 */
				if (log!=null) for(int i=0;i<pole.length;i++) log.println(pole[i]+" ");
			}
			
			// taaaak a je cas na mensi statistiku, aby se nereklo.
			// takze nejdriv na obrazovku
			System.out.println("* Statistika:");
			System.out.println("*   Pocet porovnani: "+sort.porovnani);
			System.out.println("*   Pocet vymen (presunu): "+sort.prehozu);
			
			if (log!=null) {
				log.println();
				log.println();
			}
			
			// taaak a ted tez i do souboru, pokud je zaple logovani
			if (log!=null) {
				log.println("Statistika:");
				log.println("   Pocet porovnani: "+sort.porovnani);
				log.println("   Pocet vymen (presunu): "+sort.prehozu);
			}
		}
		
		// a pokud je tedy zaple logovani, tak uzavreme soubor
		if (log!=null) log.close();
		log = null;
	}
}