/**
 * Hlavni program na generovani tabulky pro graf.
 *
 * FILE: Tabulka.java
 * @author Martin Sloup (A04372), 13. krouzek, FAV - Informatika
 * @version 1.0, 12/04/04
 */
// naimportujeme potrebne balicky
import java.io.*;
import java.util.Random;

public class Tabulka {
	public static void main(String[] args) {
		/**
		 * vytvorime objekt pro zapis z nasi suprtrupr tridy a hned priradime
		 * novou instanci
		 */
		FileLog bigtable = new FileLog("bigtable.csv");
		boolean is_ok = false;
		
		// objekt pro trideni, pritom hned vytvorime novou instanci
		Trideni sort = new Trideni();
		// objekt pro praci s nahodnyma cislama, mnohem komplexnejsi, nez Math.random();
		Random nc = new Random();
		
		// nadeklarujeme potrebna pole...
		int[] origArr;
		int[] arr;
		int[] tmpArr;
		
		// zobrazime hlavicku programu
		Tools.hlavickaProgramu();
		
		// zeptame se na pocatecni a koncovou velikost pole
		System.out.print("Zadejte pocatecni velikost pole (napr. 1): ");
		int odVelikosti = VstupData.ctiInt();
		System.out.print("Zadejte koncovou velikost pole (napr 1000): ");
		int doVelikosti = VstupData.ctiInt();
		
		// zeptame se uzivatele co vsechno ma obsahovat vystupni soubnor
		int typZapisu = 0;
		do {
			System.out.println("Co vsechno se ma obsahovat vystupni soubor?");
			System.out.println("  1 ... pocet porovnani dvou prvku");
			System.out.println("  2 ... pocet vymen (presunu) prvku");
			System.out.println("  3 ... obe vise uvedene volby");
			System.out.println();
			System.out.print("Vase volba: ");
			typZapisu = VstupData.ctiInt();
		} while (typZapisu < 1 || typZapisu > 3);
		
		//priradime do promene, ze je vse ok
		is_ok = true;
		
		/**
		 * otestujem zda se nesnazi uzivatel oblbnout program, pokud jo, vyhodime
		 * hlasku a udelame vsechno pro to, aby se nepokracovalo dal
		 */
		if (odVelikosti>doVelikosti) {
			System.out.println("Koncova velikost pole nesmi byt mensi nez pocatecni velikost pole!!!");
			// nyni neni vse ok, takze priradime do promene false
			is_ok = false;
		}
		if (odVelikosti<=0) {
			System.out.println("Pocatecni velikost pole musi byt vetsi nez cislo 0!!!");
			// nyni neni vse ok, takze priradime do promene false
			is_ok = false;
		}
		
		// pokud tedy je vse ok, tak muzeme pokracovat
		if (is_ok) {
			
			// pridelime pametovy prostor pro pole
			origArr = new int[1];

			// tak zacneme pocitat hodnoty pro pole od odVelikosti do doVelikosti
			for(int i=odVelikosti;i<=doVelikosti;i++) {
				/* 
				 * vytvorime docasne pole, aby jsem mohli zvetsit velikost pole
				 * a prigenerovat tam dalsi prvek
				 */
				arr = new int[i];
				// zkopirujeme pole
				System.arraycopy(origArr,0,arr,0,origArr.length);
				
				// prigenerujeme dalsi prvek
				arr[i-1]=nc.nextInt();
				// priradime nove pole do orig pole
				origArr=arr;
				arr = null;
				
				// nyni pridelime pametovy prostor pro originalni pole, ktere se bude pouzivat pro trideni
				tmpArr = new int[i];
				
				// do souboru pridame velikost souboru
				bigtable.print(i+";");
				
				// zkopirujeme z originalniho pole do tridiciho pole
				System.arraycopy(origArr,0,tmpArr,0,origArr.length);
				// nyni setridime pole
				sort.InsertSortASC(tmpArr);
				// zapiseme do souboru potrebne udaje pro vysledny graf / tabulku
				if (typZapisu!=2) bigtable.print(sort.porovnani+";");
				if (typZapisu!=1) bigtable.print(sort.prehozu+";");
				
				// to same provedem i pro ostatnich 5 tridicich metod
				System.arraycopy(origArr,0,tmpArr,0,origArr.length);
				sort.InsertSortDESC(tmpArr);
				if (typZapisu!=2) bigtable.print(sort.porovnani+";");
				if (typZapisu!=1) bigtable.print(sort.prehozu+";");
				
				System.arraycopy(origArr,0,tmpArr,0,origArr.length);
				sort.SelectSortASC(tmpArr);
				if (typZapisu!=2) bigtable.print(sort.porovnani+";");
				if (typZapisu!=1) bigtable.print(sort.prehozu+";");
				
				System.arraycopy(origArr,0,tmpArr,0,origArr.length);
				sort.SelectSortDESC(tmpArr);
				if (typZapisu!=2) bigtable.print(sort.porovnani+";");
				if (typZapisu!=1) bigtable.print(sort.prehozu+";");
				
				System.arraycopy(origArr,0,tmpArr,0,origArr.length);
				sort.BubbleSortASC(tmpArr);
				if (typZapisu!=2) bigtable.print(sort.porovnani+";");
				if (typZapisu!=1) bigtable.print(sort.prehozu+";");
				
				System.arraycopy(origArr,0,tmpArr,0,origArr.length);
				sort.BubbleSortDESC(tmpArr);
				if (typZapisu!=2) bigtable.print(sort.porovnani+";");
				if (typZapisu!=1) bigtable.print(sort.prehozu+";");
				
				// ukoncime radek
				bigtable.println();
			}
			// uzavreme soubor
			bigtable.close();
		}
	}
}