/**
 * Trida na trideni posloupnosti cisel v poli urcitymi metodamy.
 *
 * FILE: Trideni.java
 * @author Martin Sloup (A04372), 13. krouzek, FAV - Informatika
 * @version 1.0, 12/04/04
 */

public class Trideni {
	// promene pro uchovani poctu prehozu (vymen) a porovnani
	public int porovnani = 0;
	public int prehozu = 0;
	/**
	 * Trideni primym vkladanim (vzestupne)
	 */
	public void InsertSortASC(int[] pole) {
		int x;
		int j = 0;
		this.porovnani=0;
		this.prehozu=0;
		// projedem prvek po prvku
		for(int i=1;i<pole.length;i++) {
			// zapamatujeme prvek, ktery mame zaradit na spravne misto
			x = pole[i];
			j=i-1;
			// posuvame prvek zpatky, pokud je kam posouvat
			for (j=i;j>0;j--) {
				this.porovnani++;
				/* pokud je predchozi prvek mensi, tak jsme ho uz zaradili
				 * spravne, takze muzeme vyzkocit z posouvani a provest to same
				 * u dalsiho prvku
				 */
				if(x>pole[j-1]) break;
				// prohodime prvky (bereme to jako prehoz)
				pole[j]=pole[j-1];
				this.prehozu++;
			}
			// nyni priradime hodnotu na spravne misto (bereme to jako prehoz)
			pole[j] = x;
		}
	}

	/**
	 * Trideni primym vkladanim (sestupne)
	 */	
	public void InsertSortDESC(int[] pole) {
		int x;
		int j=0;
		this.porovnani=0;
		this.prehozu=0;
		// projedem prvek po prvku
		for(int i=1;i<pole.length;i++) {
			// zapamatujeme prvek, ktery mame zaradit na spravne misto
			x = pole[i];
			j=i-1;
			// posuvame prvek zpatky, pokud je kam posouvat
			for (j=i;j>0;j--) {
				this.porovnani++;
				/* pokud je predchozi prvek vetsi, tak jsme ho uz zaradili
				 * spravne, takze muzeme vyzkocit z posouvani a provest to same
				 * u dalsiho prvku
				 */
				if(x<pole[j-1]) break;
				// prohodime prvky
				pole[j]=pole[j-1];
				this.prehozu++;
			}
			// nyni priradime hodnotu na spravne misto
			pole[j] = x;
		}
	}

	/**
	 * Trideni primym vyberem (vzestupne)
	 */
	public void SelectSortASC(int[] pole) {
		int x;
		int nejmensi;
		this.porovnani=0;
		this.prehozu=0;
		
		// prvky budeme davat na i-te pozice
		for (int i=0;i<pole.length;i++) {
			// hledame nejmensi prvek
			nejmensi = i;
			
			for (int j=i+1;j<pole.length;j++) {
				if (pole[j]<pole[nejmensi]) nejmensi = j;
				this.porovnani++;
			}
			
			// zamenime prvky	
			x = pole[i];
			pole[i]=pole[nejmensi];
			pole[nejmensi] = x;
			this.prehozu++;
		}
	}

	/**
	 * Trideni primym vyberem (sestupne)
	 */	
	public void SelectSortDESC(int[] pole) {
		int x;
		int nejvetsi;
		this.porovnani=0;
		this.prehozu=0;
		
		// prvky budeme davat na i-te pozice
		for (int i=0;i<pole.length;i++) {
			// hledame nejvetsi prvek
			nejvetsi = i;
			
			for (int j=i+1;j<pole.length;j++) {
				if (pole[j]<pole[nejvetsi]) nejvetsi = j;
				this.porovnani++;
			}
			
			// zamenime prvky	
			x = pole[i];
			pole[i]=pole[nejvetsi];
			pole[nejvetsi] = x;
			this.prehozu++;
		}
	}
	
	/**
	 * Trideni primou vymenou (vzestupne)
	 */
	public void BubbleSortASC(int[] pole) {
		int x;
		this.porovnani=0;
		this.prehozu=0;
		
		for(int i=1;i<pole.length;i++) {
			for(int j=pole.length-1;j>=i;j--) {
				// je prvek zarazen spravne?
				this.porovnani++;
				if (pole[j-1]>pole[j]) {
					// zamenime prvky
					x = pole[j-1];
					pole[j-1] = pole[j];
					pole[j] = x;
					this.prehozu++;
				}
			}
		}
	}

	/**
	 * Trideni primou vymenou (sestupne)
	 */	
	public void BubbleSortDESC(int[] pole) {
		int x;
		this.porovnani=0;
		this.prehozu=0;
		
		for(int i=pole.length-2;i>0;i--) {
			for(int j=i;j<pole.length;j++) {
				this.porovnani++;
				// je prvek zarazen spravne?
				if (pole[j-1]<pole[j]) {
					// zamenime prvky
					x = pole[j-1];
					pole[j-1] = pole[j];
					pole[j] = x;
					this.prehozu++;
				}
			}
		}
	}

}